---
title: Create an execution policy
description: Create a new execution policy.
breadcrumbs: Docs > API > Create an execution policy
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create an execution policy

## v2 (latest)

{% alert level="warning" %}
**Note**: This endpoint is in preview and is subject to change.
If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help.md).
{% /alert %}

| Datadog site      | API endpoint                                                         |
| ----------------- | -------------------------------------------------------------------- |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/actions/execution-policies     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/actions/execution-policies |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/actions/execution-policies |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/actions/execution-policies      |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/actions/execution-policies |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/actions/execution-policies |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/actions/execution-policies |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/actions/execution-policies      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/actions/execution-policies  |

### Overview

Create a new execution policy.

This endpoint requires the `execution_groups_write` permission.

### Request

#### Body Data (required)

The execution policy to create.

{% tabs %}
{% tab label="Model" %}
| Parent field         | Field                               | Type     | Description                                                                                                                                                                                                                                          |
| -------------------- | ----------------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                      | data [*required*]                   | object   | Object for a single execution policy.                                                                                                                                                                                                                |
| data                 | attributes [*required*]             | object   | Attributes used to create or update an execution policy.                                                                                                                                                                                             |
| attributes           | action_pattern [*required*]         | object   | The set of actions this policy applies to.                                                                                                                                                                                                           |
| action_pattern       | action_fqns [*required*]            | [string] | The fully qualified action names this policy matches. Use `*` to match all actions of the integration, or a fully qualified name prefixed with the integration's action namespace (for example `com.datadoghq.script.*` for the Script integration). |
| action_pattern       | integration [*required*]            | enum     | The integration the action pattern applies to. Allowed enum values: `INTEGRATION_KUBERNETES`, `INTEGRATION_SCRIPT`, `INTEGRATION_REMOTE_ACTION`, `INTEGRATION_SLACK`.                                                                                |
| attributes           | effect [*required*]                 | enum     | Whether the policy allows or denies matching actions. Allowed enum values: `allow`, `deny`.                                                                                                                                                          |
| attributes           | name [*required*]                   | string   | The name of the execution policy.                                                                                                                                                                                                                    |
| attributes           | scope                               | object   | Restricts where the policy applies. At most one scope type can be set, and it must match the action pattern's integration. An empty object means the policy has no scope restriction.                                                                |
| scope                | kubernetes                          | object   | Restricts the policy to specific Kubernetes namespaces.                                                                                                                                                                                              |
| kubernetes           | rules [*required*]                  | [object] | The Kubernetes scope rules.                                                                                                                                                                                                                          |
| rules                | target_namespaces [*required*]      | [string] | The Kubernetes namespaces this rule applies to.                                                                                                                                                                                                      |
| scope                | remote_action_rshell                | object   | Restricts the policy to specific remote shell paths.                                                                                                                                                                                                 |
| remote_action_rshell | rules [*required*]                  | [object] | The remote shell scope rules.                                                                                                                                                                                                                        |
| rules                | access [*required*]                 | enum     | The level of remote shell access granted for the target paths. Allowed enum values: `read_only`, `read_write`.                                                                                                                                       |
| rules                | target_paths [*required*]           | [string] | The file system paths this rule applies to.                                                                                                                                                                                                          |
| scope                | scripts                             | object   | Restricts the policy to specific scripts.                                                                                                                                                                                                            |
| scripts              | rules [*required*]                  | [object] | The script scope rules.                                                                                                                                                                                                                              |
| rules                | target_script_names [*required*]    | [string] | The script names this rule applies to.                                                                                                                                                                                                               |
| scope                | slack                               | object   | Restricts the policy to specific Slack private channel names.                                                                                                                                                                                        |
| slack                | rules [*required*]                  | [object] | The Slack scope rules.                                                                                                                                                                                                                               |
| rules                | channel_name_selectors [*required*] | [string] | The private channel name selectors this rule applies to. Selectors are lowercase private channel names without the leading `#`, and can contain `*` wildcards. Use `*` alone to match any private channel name.                                      |
| attributes           | targets                             | [object] | The targets this policy applies to.                                                                                                                                                                                                                  |
| targets              | agent_tags [*required*]             | [string] | The tags identifying the target.                                                                                                                                                                                                                     |
| targets              | name                                | string   | A human-readable name for the target.                                                                                                                                                                                                                |
| data                 | type [*required*]                   | enum     | The type of the resource. The value should always be `execution_policy`. Allowed enum values: `execution_policy`. Default: `execution_policy`.                                                                                                       |
{% /tab %}

{% tab label="Example" %}
**Create a Slack execution policy returns "Created" response**

```json
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SLACK",
        "action_fqns": [
          "com.datadoghq.slack.*"
        ]
      }
    }
  }
}
```

**Create a Slack execution policy with scope and targets returns "Created" response**

```json
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SLACK",
        "action_fqns": [
          "com.datadoghq.slack.*"
        ]
      },
      "scope": {
        "slack": {
          "rules": [
            {
              "channel_name_selectors": [
                "incident-*"
              ]
            }
          ]
        }
      },
      "targets": [
        {
          "name": "Incident workspace",
          "agent_tags": [
            "slack_workspace_id:T01234567"
          ]
        }
      ]
    }
  }
}
```

**Create an execution policy returns "Created" response**

```json
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SCRIPT",
        "action_fqns": [
          "com.datadoghq.script.*"
        ]
      }
    }
  }
}
```
{% /tab %}
{% /tabs %}

### Response

{% tabs %}
{% tab label="201" %}
Created

{% tabs %}
{% tab label="Model" %}
Response object that includes a single execution policy.

| Parent field         | Field                               | Type      | Description                                                                                                                                                                                                                                          |
| -------------------- | ----------------------------------- | --------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                      | data [*required*]                   | object    | Object for a single execution policy.                                                                                                                                                                                                                |
| data                 | attributes [*required*]             | object    | An execution policy.                                                                                                                                                                                                                                 |
| attributes           | action_pattern [*required*]         | object    | The set of actions this policy applies to.                                                                                                                                                                                                           |
| action_pattern       | action_fqns [*required*]            | [string]  | The fully qualified action names this policy matches. Use `*` to match all actions of the integration, or a fully qualified name prefixed with the integration's action namespace (for example `com.datadoghq.script.*` for the Script integration). |
| action_pattern       | integration [*required*]            | enum      | The integration the action pattern applies to. Allowed enum values: `INTEGRATION_KUBERNETES`, `INTEGRATION_SCRIPT`, `INTEGRATION_REMOTE_ACTION`, `INTEGRATION_SLACK`.                                                                                |
| attributes           | created_at [*required*]             | date-time | The date and time the execution policy was created.                                                                                                                                                                                                  |
| attributes           | created_by [*required*]             | string    | The ID of the user who created the execution policy.                                                                                                                                                                                                 |
| attributes           | effect [*required*]                 | enum      | Whether the policy allows or denies matching actions. Allowed enum values: `allow`, `deny`.                                                                                                                                                          |
| attributes           | name [*required*]                   | string    | The name of the execution policy.                                                                                                                                                                                                                    |
| attributes           | scope                               | object    | Restricts where the policy applies. At most one scope type can be set, and it must match the action pattern's integration. An empty object means the policy has no scope restriction.                                                                |
| scope                | kubernetes                          | object    | Restricts the policy to specific Kubernetes namespaces.                                                                                                                                                                                              |
| kubernetes           | rules [*required*]                  | [object]  | The Kubernetes scope rules.                                                                                                                                                                                                                          |
| rules                | target_namespaces [*required*]      | [string]  | The Kubernetes namespaces this rule applies to.                                                                                                                                                                                                      |
| scope                | remote_action_rshell                | object    | Restricts the policy to specific remote shell paths.                                                                                                                                                                                                 |
| remote_action_rshell | rules [*required*]                  | [object]  | The remote shell scope rules.                                                                                                                                                                                                                        |
| rules                | access [*required*]                 | enum      | The level of remote shell access granted for the target paths. Allowed enum values: `read_only`, `read_write`.                                                                                                                                       |
| rules                | target_paths [*required*]           | [string]  | The file system paths this rule applies to.                                                                                                                                                                                                          |
| scope                | scripts                             | object    | Restricts the policy to specific scripts.                                                                                                                                                                                                            |
| scripts              | rules [*required*]                  | [object]  | The script scope rules.                                                                                                                                                                                                                              |
| rules                | target_script_names [*required*]    | [string]  | The script names this rule applies to.                                                                                                                                                                                                               |
| scope                | slack                               | object    | Restricts the policy to specific Slack private channel names.                                                                                                                                                                                        |
| slack                | rules [*required*]                  | [object]  | The Slack scope rules.                                                                                                                                                                                                                               |
| rules                | channel_name_selectors [*required*] | [string]  | The private channel name selectors this rule applies to. Selectors are lowercase private channel names without the leading `#`, and can contain `*` wildcards. Use `*` alone to match any private channel name.                                      |
| attributes           | targets [*required*]                | [object]  | The targets this policy applies to.                                                                                                                                                                                                                  |
| targets              | agent_tags [*required*]             | [string]  | The tags identifying the target.                                                                                                                                                                                                                     |
| targets              | name                                | string    | A human-readable name for the target.                                                                                                                                                                                                                |
| attributes           | updated_at [*required*]             | date-time | The date and time the execution policy was last updated.                                                                                                                                                                                             |
| attributes           | updated_by [*required*]             | string    | The ID of the user who last updated the execution policy.                                                                                                                                                                                            |
| attributes           | version [*required*]                | int32     | The version of the execution policy. Incremented on every update.                                                                                                                                                                                    |
| data                 | id [*required*]                     | string    | The ID of the execution policy. Read-only.                                                                                                                                                                                                           |
| data                 | type [*required*]                   | enum      | The type of the resource. The value should always be `execution_policy`. Allowed enum values: `execution_policy`. Default: `execution_policy`.                                                                                                       |
{% /tab %}

{% tab label="Example" %}
```json
{
  "data": {
    "attributes": {
      "action_pattern": {
        "action_fqns": [
          "com.datadoghq.script.*"
        ],
        "integration": "INTEGRATION_SCRIPT"
      },
      "created_at": "2026-01-15T10:00:00.000Z",
      "created_by": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "effect": "allow",
      "name": "Block prod restarts",
      "scope": {
        "kubernetes": {
          "rules": [
            {
              "target_namespaces": [
                "default"
              ]
            }
          ]
        },
        "remote_action_rshell": {
          "rules": [
            {
              "access": "read_only",
              "target_paths": [
                "/var/log"
              ]
            }
          ]
        },
        "scripts": {
          "rules": [
            {
              "target_script_names": [
                "restart_service.sh"
              ]
            }
          ]
        },
        "slack": {
          "rules": [
            {
              "channel_name_selectors": [
                "incident-*"
              ]
            }
          ]
        }
      },
      "targets": [
        {
          "agent_tags": [
            "env:prod"
          ],
          "name": "Production hosts"
        }
      ],
      "updated_at": "2026-01-15T10:00:00.000Z",
      "updated_by": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
      "version": 1
    },
    "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
    "type": "execution_policy"
  }
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="400" %}
Bad Request

{% tabs %}
{% tab label="Model" %}
API error response.

| Parent field | Field               | Type     | Description                                                                     |
| ------------ | ------------------- | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail              | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                | object   | Non-standard meta-information about the error                                   |
| errors       | source              | object   | References to the source of the error.                                          |
| source       | header              | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter           | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer             | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status              | string   | Status code of the response.                                                    |
| errors       | title               | string   | Short human-readable summary of the error.                                      |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="403" %}
Forbidden

{% tabs %}
{% tab label="Model" %}
API error response.

| Parent field | Field               | Type     | Description                                                                     |
| ------------ | ------------------- | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail              | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                | object   | Non-standard meta-information about the error                                   |
| errors       | source              | object   | References to the source of the error.                                          |
| source       | header              | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter           | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer             | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status              | string   | Status code of the response.                                                    |
| errors       | title               | string   | Short human-readable summary of the error.                                      |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}

{% tab label="429" %}
Too many requests

{% tabs %}
{% tab label="Model" %}
API error response.

| Field               | Type     | Description       |
| ------------------- | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |
{% /tab %}

{% tab label="Example" %}
```json
{
  "errors": [
    "Bad Request"
  ]
}
```
{% /tab %}
{% /tabs %}
{% /tab %}
{% /tabs %}

### Code Example

{% tabs %}
{% tab label="Curl" %}
```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/actions/execution-policies" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SLACK",
        "action_fqns": [
          "com.datadoghq.slack.*"
        ]
      }
    }
  }
}
EOF
```

```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/actions/execution-policies" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SLACK",
        "action_fqns": [
          "com.datadoghq.slack.*"
        ]
      },
      "scope": {
        "slack": {
          "rules": [
            {
              "channel_name_selectors": [
                "incident-*"
              ]
            }
          ]
        }
      },
      "targets": [
        {
          "name": "Incident workspace",
          "agent_tags": [
            "slack_workspace_id:T01234567"
          ]
        }
      ]
    }
  }
}
EOF
```

```bash
# Set your Datadog site and credentials
export DD_SITE="datadoghq.com" # Or us3.datadoghq.com, us5.datadoghq.com, datadoghq.eu, ap1.datadoghq.com, ap2.datadoghq.com, uk1.datadoghq.com, ddog-gov.com, us2.ddog-gov.com
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

curl -X POST "https://api.${DD_SITE}/api/v2/actions/execution-policies" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "type": "execution_policy",
    "attributes": {
      "name": "Cassette Execution Policy exampleexecutionpolicy",
      "effect": "allow",
      "action_pattern": {
        "integration": "INTEGRATION_SCRIPT",
        "action_fqns": [
          "com.datadoghq.script.*"
        ]
      }
    }
  }
}
EOF
```
{% /tab %}

{% tab label="Go" %}
```go
// Create an execution policy returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ExecutionPolicyCreateRequest{
		Data: datadogV2.ExecutionPolicyCreateRequestData{
			Type: datadogV2.EXECUTIONPOLICYTYPE_EXECUTION_POLICY,
			Attributes: datadogV2.ExecutionPolicyWriteAttributes{
				Name:   "Cassette Execution Policy exampleexecutionpolicy",
				Effect: datadogV2.EXECUTIONPOLICYEFFECT_ALLOW,
				ActionPattern: datadogV2.ExecutionPolicyActionPattern{
					Integration: datadogV2.EXECUTIONPOLICYINTEGRATION_INTEGRATION_SCRIPT,
					ActionFqns: []string{
						"com.datadoghq.script.*",
					},
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateExecutionPolicy", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewExecutionPolicyApi(apiClient)
	resp, r, err := api.CreateExecutionPolicy(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ExecutionPolicyApi.CreateExecutionPolicy`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ExecutionPolicyApi.CreateExecutionPolicy`:\n%s\n", responseContent)
}
```

```go
// Create an execution policy with scope and targets returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ExecutionPolicyCreateRequest{
		Data: datadogV2.ExecutionPolicyCreateRequestData{
			Type: datadogV2.EXECUTIONPOLICYTYPE_EXECUTION_POLICY,
			Attributes: datadogV2.ExecutionPolicyWriteAttributes{
				Name:   "Cassette Execution Policy exampleexecutionpolicy",
				Effect: datadogV2.EXECUTIONPOLICYEFFECT_ALLOW,
				ActionPattern: datadogV2.ExecutionPolicyActionPattern{
					Integration: datadogV2.EXECUTIONPOLICYINTEGRATION_INTEGRATION_SCRIPT,
					ActionFqns: []string{
						"com.datadoghq.script.*",
					},
				},
				Scope: &datadogV2.ExecutionPolicyScope{
					Scripts: &datadogV2.ExecutionPolicyScriptScope{
						Rules: []datadogV2.ExecutionPolicyScriptScopeRule{
							{
								TargetScriptNames: []string{
									"restart_service.sh",
								},
							},
						},
					},
				},
				Targets: []datadogV2.ExecutionPolicyTarget{
					{
						Name: *datadog.NewNullableString(datadog.PtrString("Production hosts")),
						AgentTags: []string{
							"env:prod",
						},
					},
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateExecutionPolicy", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewExecutionPolicyApi(apiClient)
	resp, r, err := api.CreateExecutionPolicy(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ExecutionPolicyApi.CreateExecutionPolicy`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ExecutionPolicyApi.CreateExecutionPolicy`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
```
{% /tab %}

{% tab label="Java" %}
```java
// Create an execution policy returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ExecutionPolicyApi;
import com.datadog.api.client.v2.model.ExecutionPolicyActionPattern;
import com.datadog.api.client.v2.model.ExecutionPolicyCreateRequest;
import com.datadog.api.client.v2.model.ExecutionPolicyCreateRequestData;
import com.datadog.api.client.v2.model.ExecutionPolicyEffect;
import com.datadog.api.client.v2.model.ExecutionPolicyIntegration;
import com.datadog.api.client.v2.model.ExecutionPolicyResponse;
import com.datadog.api.client.v2.model.ExecutionPolicyType;
import com.datadog.api.client.v2.model.ExecutionPolicyWriteAttributes;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.createExecutionPolicy", true);
    ExecutionPolicyApi apiInstance = new ExecutionPolicyApi(defaultClient);

    ExecutionPolicyCreateRequest body =
        new ExecutionPolicyCreateRequest()
            .data(
                new ExecutionPolicyCreateRequestData()
                    .type(ExecutionPolicyType.EXECUTION_POLICY)
                    .attributes(
                        new ExecutionPolicyWriteAttributes()
                            .name("Cassette Execution Policy exampleexecutionpolicy")
                            .effect(ExecutionPolicyEffect.ALLOW)
                            .actionPattern(
                                new ExecutionPolicyActionPattern()
                                    .integration(ExecutionPolicyIntegration.INTEGRATION_SCRIPT)
                                    .actionFqns(
                                        Collections.singletonList("com.datadoghq.script.*")))));

    try {
      ExecutionPolicyResponse result = apiInstance.createExecutionPolicy(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ExecutionPolicyApi#createExecutionPolicy");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

```java
// Create an execution policy with scope and targets returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ExecutionPolicyApi;
import com.datadog.api.client.v2.model.ExecutionPolicyActionPattern;
import com.datadog.api.client.v2.model.ExecutionPolicyCreateRequest;
import com.datadog.api.client.v2.model.ExecutionPolicyCreateRequestData;
import com.datadog.api.client.v2.model.ExecutionPolicyEffect;
import com.datadog.api.client.v2.model.ExecutionPolicyIntegration;
import com.datadog.api.client.v2.model.ExecutionPolicyResponse;
import com.datadog.api.client.v2.model.ExecutionPolicyScope;
import com.datadog.api.client.v2.model.ExecutionPolicyScriptScope;
import com.datadog.api.client.v2.model.ExecutionPolicyScriptScopeRule;
import com.datadog.api.client.v2.model.ExecutionPolicyTarget;
import com.datadog.api.client.v2.model.ExecutionPolicyType;
import com.datadog.api.client.v2.model.ExecutionPolicyWriteAttributes;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.createExecutionPolicy", true);
    ExecutionPolicyApi apiInstance = new ExecutionPolicyApi(defaultClient);

    ExecutionPolicyCreateRequest body =
        new ExecutionPolicyCreateRequest()
            .data(
                new ExecutionPolicyCreateRequestData()
                    .type(ExecutionPolicyType.EXECUTION_POLICY)
                    .attributes(
                        new ExecutionPolicyWriteAttributes()
                            .name("Cassette Execution Policy exampleexecutionpolicy")
                            .effect(ExecutionPolicyEffect.ALLOW)
                            .actionPattern(
                                new ExecutionPolicyActionPattern()
                                    .integration(ExecutionPolicyIntegration.INTEGRATION_SCRIPT)
                                    .actionFqns(
                                        Collections.singletonList("com.datadoghq.script.*")))
                            .scope(
                                new ExecutionPolicyScope()
                                    .scripts(
                                        new ExecutionPolicyScriptScope()
                                            .rules(
                                                Collections.singletonList(
                                                    new ExecutionPolicyScriptScopeRule()
                                                        .targetScriptNames(
                                                            Collections.singletonList(
                                                                "restart_service.sh"))))))
                            .targets(
                                Collections.singletonList(
                                    new ExecutionPolicyTarget()
                                        .name("Production hosts")
                                        .agentTags(Collections.singletonList("env:prod"))))));

    try {
      ExecutionPolicyResponse result = apiInstance.createExecutionPolicy(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ExecutionPolicyApi#createExecutionPolicy");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
```
{% /tab %}

{% tab label="Python" %}
```python
"""
Create an execution policy returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.execution_policy_api import ExecutionPolicyApi
from datadog_api_client.v2.model.execution_policy_action_pattern import ExecutionPolicyActionPattern
from datadog_api_client.v2.model.execution_policy_create_request import ExecutionPolicyCreateRequest
from datadog_api_client.v2.model.execution_policy_create_request_data import ExecutionPolicyCreateRequestData
from datadog_api_client.v2.model.execution_policy_effect import ExecutionPolicyEffect
from datadog_api_client.v2.model.execution_policy_integration import ExecutionPolicyIntegration
from datadog_api_client.v2.model.execution_policy_type import ExecutionPolicyType
from datadog_api_client.v2.model.execution_policy_write_attributes import ExecutionPolicyWriteAttributes

body = ExecutionPolicyCreateRequest(
    data=ExecutionPolicyCreateRequestData(
        type=ExecutionPolicyType.EXECUTION_POLICY,
        attributes=ExecutionPolicyWriteAttributes(
            name="Cassette Execution Policy exampleexecutionpolicy",
            effect=ExecutionPolicyEffect.ALLOW,
            action_pattern=ExecutionPolicyActionPattern(
                integration=ExecutionPolicyIntegration.INTEGRATION_SCRIPT,
                action_fqns=[
                    "com.datadoghq.script.*",
                ],
            ),
        ),
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["create_execution_policy"] = True
with ApiClient(configuration) as api_client:
    api_instance = ExecutionPolicyApi(api_client)
    response = api_instance.create_execution_policy(body=body)

    print(response)
```

```python
"""
Create an execution policy with scope and targets returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.execution_policy_api import ExecutionPolicyApi
from datadog_api_client.v2.model.execution_policy_action_pattern import ExecutionPolicyActionPattern
from datadog_api_client.v2.model.execution_policy_create_request import ExecutionPolicyCreateRequest
from datadog_api_client.v2.model.execution_policy_create_request_data import ExecutionPolicyCreateRequestData
from datadog_api_client.v2.model.execution_policy_effect import ExecutionPolicyEffect
from datadog_api_client.v2.model.execution_policy_integration import ExecutionPolicyIntegration
from datadog_api_client.v2.model.execution_policy_scope import ExecutionPolicyScope
from datadog_api_client.v2.model.execution_policy_script_scope import ExecutionPolicyScriptScope
from datadog_api_client.v2.model.execution_policy_script_scope_rule import ExecutionPolicyScriptScopeRule
from datadog_api_client.v2.model.execution_policy_target import ExecutionPolicyTarget
from datadog_api_client.v2.model.execution_policy_type import ExecutionPolicyType
from datadog_api_client.v2.model.execution_policy_write_attributes import ExecutionPolicyWriteAttributes

body = ExecutionPolicyCreateRequest(
    data=ExecutionPolicyCreateRequestData(
        type=ExecutionPolicyType.EXECUTION_POLICY,
        attributes=ExecutionPolicyWriteAttributes(
            name="Cassette Execution Policy exampleexecutionpolicy",
            effect=ExecutionPolicyEffect.ALLOW,
            action_pattern=ExecutionPolicyActionPattern(
                integration=ExecutionPolicyIntegration.INTEGRATION_SCRIPT,
                action_fqns=[
                    "com.datadoghq.script.*",
                ],
            ),
            scope=ExecutionPolicyScope(
                scripts=ExecutionPolicyScriptScope(
                    rules=[
                        ExecutionPolicyScriptScopeRule(
                            target_script_names=[
                                "restart_service.sh",
                            ],
                        ),
                    ],
                ),
            ),
            targets=[
                ExecutionPolicyTarget(
                    name="Production hosts",
                    agent_tags=[
                        "env:prod",
                    ],
                ),
            ],
        ),
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["create_execution_policy"] = True
with ApiClient(configuration) as api_client:
    api_instance = ExecutionPolicyApi(api_client)
    response = api_instance.create_execution_policy(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
```
{% /tab %}

{% tab label="Ruby" %}
```ruby
# Create an execution policy returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.create_execution_policy".to_sym] = true
end
api_instance = DatadogAPIClient::V2::ExecutionPolicyAPI.new

body = DatadogAPIClient::V2::ExecutionPolicyCreateRequest.new({
  data: DatadogAPIClient::V2::ExecutionPolicyCreateRequestData.new({
    type: DatadogAPIClient::V2::ExecutionPolicyType::EXECUTION_POLICY,
    attributes: DatadogAPIClient::V2::ExecutionPolicyWriteAttributes.new({
      name: "Cassette Execution Policy exampleexecutionpolicy",
      effect: DatadogAPIClient::V2::ExecutionPolicyEffect::ALLOW,
      action_pattern: DatadogAPIClient::V2::ExecutionPolicyActionPattern.new({
        integration: DatadogAPIClient::V2::ExecutionPolicyIntegration::INTEGRATION_SCRIPT,
        action_fqns: [
          "com.datadoghq.script.*",
        ],
      }),
    }),
  }),
})
p api_instance.create_execution_policy(body)
```

```ruby
# Create an execution policy with scope and targets returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.create_execution_policy".to_sym] = true
end
api_instance = DatadogAPIClient::V2::ExecutionPolicyAPI.new

body = DatadogAPIClient::V2::ExecutionPolicyCreateRequest.new({
  data: DatadogAPIClient::V2::ExecutionPolicyCreateRequestData.new({
    type: DatadogAPIClient::V2::ExecutionPolicyType::EXECUTION_POLICY,
    attributes: DatadogAPIClient::V2::ExecutionPolicyWriteAttributes.new({
      name: "Cassette Execution Policy exampleexecutionpolicy",
      effect: DatadogAPIClient::V2::ExecutionPolicyEffect::ALLOW,
      action_pattern: DatadogAPIClient::V2::ExecutionPolicyActionPattern.new({
        integration: DatadogAPIClient::V2::ExecutionPolicyIntegration::INTEGRATION_SCRIPT,
        action_fqns: [
          "com.datadoghq.script.*",
        ],
      }),
      scope: DatadogAPIClient::V2::ExecutionPolicyScope.new({
        scripts: DatadogAPIClient::V2::ExecutionPolicyScriptScope.new({
          rules: [
            DatadogAPIClient::V2::ExecutionPolicyScriptScopeRule.new({
              target_script_names: [
                "restart_service.sh",
              ],
            }),
          ],
        }),
      }),
      targets: [
        DatadogAPIClient::V2::ExecutionPolicyTarget.new({
          name: "Production hosts",
          agent_tags: [
            "env:prod",
          ],
        }),
      ],
    }),
  }),
})
p api_instance.create_execution_policy(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" ruby "example.rb"
```
{% /tab %}

{% tab label="Rust" %}
```rust
// Create an execution policy returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_execution_policy::ExecutionPolicyAPI;
use datadog_api_client::datadogV2::model::ExecutionPolicyActionPattern;
use datadog_api_client::datadogV2::model::ExecutionPolicyCreateRequest;
use datadog_api_client::datadogV2::model::ExecutionPolicyCreateRequestData;
use datadog_api_client::datadogV2::model::ExecutionPolicyEffect;
use datadog_api_client::datadogV2::model::ExecutionPolicyIntegration;
use datadog_api_client::datadogV2::model::ExecutionPolicyType;
use datadog_api_client::datadogV2::model::ExecutionPolicyWriteAttributes;

#[tokio::main]
async fn main() {
    let body = ExecutionPolicyCreateRequest::new(ExecutionPolicyCreateRequestData::new(
        ExecutionPolicyWriteAttributes::new(
            ExecutionPolicyActionPattern::new(
                vec!["com.datadoghq.script.*".to_string()],
                ExecutionPolicyIntegration::INTEGRATION_SCRIPT,
            ),
            ExecutionPolicyEffect::ALLOW,
            "Cassette Execution Policy exampleexecutionpolicy".to_string(),
        ),
        ExecutionPolicyType::EXECUTION_POLICY,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.create_execution_policy", true);
    let api = ExecutionPolicyAPI::with_config(configuration);
    let resp = api.create_execution_policy(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

```rust
// Create an execution policy with scope and targets returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_execution_policy::ExecutionPolicyAPI;
use datadog_api_client::datadogV2::model::ExecutionPolicyActionPattern;
use datadog_api_client::datadogV2::model::ExecutionPolicyCreateRequest;
use datadog_api_client::datadogV2::model::ExecutionPolicyCreateRequestData;
use datadog_api_client::datadogV2::model::ExecutionPolicyEffect;
use datadog_api_client::datadogV2::model::ExecutionPolicyIntegration;
use datadog_api_client::datadogV2::model::ExecutionPolicyScope;
use datadog_api_client::datadogV2::model::ExecutionPolicyScriptScope;
use datadog_api_client::datadogV2::model::ExecutionPolicyScriptScopeRule;
use datadog_api_client::datadogV2::model::ExecutionPolicyTarget;
use datadog_api_client::datadogV2::model::ExecutionPolicyType;
use datadog_api_client::datadogV2::model::ExecutionPolicyWriteAttributes;

#[tokio::main]
async fn main() {
    let body = ExecutionPolicyCreateRequest::new(ExecutionPolicyCreateRequestData::new(
        ExecutionPolicyWriteAttributes::new(
            ExecutionPolicyActionPattern::new(
                vec!["com.datadoghq.script.*".to_string()],
                ExecutionPolicyIntegration::INTEGRATION_SCRIPT,
            ),
            ExecutionPolicyEffect::ALLOW,
            "Cassette Execution Policy exampleexecutionpolicy".to_string(),
        )
        .scope(
            ExecutionPolicyScope::new().scripts(ExecutionPolicyScriptScope::new(vec![
                ExecutionPolicyScriptScopeRule::new(vec!["restart_service.sh".to_string()]),
            ])),
        )
        .targets(vec![ExecutionPolicyTarget::new(vec![
            "env:prod".to_string()
        ])
        .name(Some("Production hosts".to_string()))]),
        ExecutionPolicyType::EXECUTION_POLICY,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.create_execution_policy", true);
    let api = ExecutionPolicyAPI::with_config(configuration);
    let resp = api.create_execution_policy(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
```
{% /tab %}

{% tab label="TypeScript" %}
```typescript
/**
 * Create an execution policy returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.createExecutionPolicy"] = true;
const apiInstance = new v2.ExecutionPolicyApi(configuration);

const params: v2.ExecutionPolicyApiCreateExecutionPolicyRequest = {
  body: {
    data: {
      type: "execution_policy",
      attributes: {
        name: "Cassette Execution Policy exampleexecutionpolicy",
        effect: "allow",
        actionPattern: {
          integration: "INTEGRATION_SCRIPT",
          actionFqns: ["com.datadoghq.script.*"],
        },
      },
    },
  },
};

apiInstance
  .createExecutionPolicy(params)
  .then((data: v2.ExecutionPolicyResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

```typescript
/**
 * Create an execution policy with scope and targets returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations["v2.createExecutionPolicy"] = true;
const apiInstance = new v2.ExecutionPolicyApi(configuration);

const params: v2.ExecutionPolicyApiCreateExecutionPolicyRequest = {
  body: {
    data: {
      type: "execution_policy",
      attributes: {
        name: "Cassette Execution Policy exampleexecutionpolicy",
        effect: "allow",
        actionPattern: {
          integration: "INTEGRATION_SCRIPT",
          actionFqns: ["com.datadoghq.script.*"],
        },
        scope: {
          scripts: {
            rules: [
              {
                targetScriptNames: ["restart_service.sh"],
              },
            ],
          },
        },
        targets: [
          {
            name: "Production hosts",
            agentTags: ["env:prod"],
          },
        ],
      },
    },
  },
};

apiInstance
  .createExecutionPolicy(params)
  .then((data: v2.ExecutionPolicyResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:

```bash
DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" npx tsx "example.ts"
```
{% /tab %}
{% /tabs %}
